//--------------------------------------------------------------------------------------
// Bindings
//--------------------------------------------------------------------------------------

Texture2D<float4> tCurr : register(t0);
Texture2D<float4> tPrev: register(t1);
RWTexture2D<float4> tRes: register(u0);
SamplerState s0 : register(s0);

//--------------------------------------------------------------------------------------
// Structures
//--------------------------------------------------------------------------------------

[numthreads(8, 8, 1)]
void Accumulate(int3 DTid : SV_DispatchThreadID)
{
    int frame_count = 2;
    float4 prev_s = (tPrev[DTid.xy]);
    tRes[DTid.xy] = (tCurr[DTid.xy] + prev_s* ((float) frame_count - 1.0f) ) / ((float) frame_count);
}

[numthreads(8, 8, 1)]
void Blit(int3 DTid : SV_DispatchThreadID)
{
    tRes[DTid.xy] = tCurr[DTid.xy];
}